2019-12-26 17:35:41 +00:00
#!/bin/bash
set -ex
set -o pipefail
trap "exit" INT TERM
2020-04-17 15:47:01 +00:00
trap 'kill $(jobs -pr) ||:' EXIT
2019-12-26 17:35:41 +00:00
2020-02-27 20:02:50 +00:00
stage = ${ stage :- }
2020-03-24 17:33:18 +00:00
script_dir = " $( cd " $( dirname " ${ BASH_SOURCE [0] } " ) " >/dev/null 2>& 1 && pwd ) "
2019-12-26 17:35:41 +00:00
function configure
{
2020-02-25 19:51:09 +00:00
# Use the new config for both servers, so that we can change it in a PR.
2019-12-26 21:33:10 +00:00
rm right/config/config.d/text_log.xml || :
2020-02-25 19:51:09 +00:00
cp -rv right/config left || :
sed -i 's/<tcp_port>9000/<tcp_port>9001/g' left/config/config.xml
sed -i 's/<tcp_port>9000/<tcp_port>9002/g' right/config/config.xml
2020-01-14 19:05:58 +00:00
# Start a temporary server to rename the tables
2020-04-17 15:47:01 +00:00
while killall clickhouse-server; do echo . ; sleep 1 ; done
2020-01-14 19:05:58 +00:00
echo all killed
set -m # Spawn temporary in its own process groups
2020-04-17 15:47:01 +00:00
left/clickhouse-server --config-file= left/config/config.xml -- --path db0 & > setup-server-log.log &
2020-01-14 19:05:58 +00:00
left_pid = $!
kill -0 $left_pid
disown $left_pid
set +m
2020-04-17 15:47:01 +00:00
while ! clickhouse-client --port 9001 --query "select 1" ; do kill -0 $left_pid ; echo . ; sleep 1 ; done
2020-01-14 19:05:58 +00:00
echo server for setup started
2020-04-17 15:47:01 +00:00
clickhouse-client --port 9001 --query "create database test" || :
clickhouse-client --port 9001 --query "rename table datasets.hits_v1 to test.hits" || :
2020-02-14 12:55:47 +00:00
2020-04-17 15:47:01 +00:00
while killall clickhouse-server; do echo . ; sleep 1 ; done
2020-02-14 12:55:47 +00:00
echo all killed
# Remove logs etc, because they will be updated, and sharing them between
# servers with hardlink might cause unpredictable behavior.
rm db0/data/system/* -rf || :
2020-02-21 19:58:52 +00:00
rm db0/metadata/system/* -rf || :
2019-12-26 17:35:41 +00:00
2020-01-14 19:05:58 +00:00
# Make copies of the original db for both servers. Use hardlinks instead
2020-04-17 15:47:01 +00:00
# of copying. Be careful to remove preprocessed configs and system tables,or
# it can lead to weird effects.
2020-01-14 19:05:58 +00:00
rm -r left/db || :
rm -r right/db || :
2020-04-13 19:06:07 +00:00
rm -r db0/preprocessed_configs || :
2020-04-17 15:47:01 +00:00
rm -r db/{ data,metadata} /system || :
2020-01-14 19:05:58 +00:00
cp -al db0/ left/db/
cp -al db0/ right/db/
2020-02-25 19:51:09 +00:00
}
function restart
{
2020-04-17 15:47:01 +00:00
while killall clickhouse-server; do echo . ; sleep 1 ; done
2020-02-25 19:51:09 +00:00
echo all killed
2020-01-14 19:05:58 +00:00
set -m # Spawn servers in their own process groups
2019-12-26 17:35:41 +00:00
2020-04-17 15:47:01 +00:00
left/clickhouse-server --config-file= left/config/config.xml -- --path left/db & >> left-server-log.log &
2019-12-26 17:35:41 +00:00
left_pid = $!
kill -0 $left_pid
disown $left_pid
2020-04-17 15:47:01 +00:00
right/clickhouse-server --config-file= right/config/config.xml -- --path right/db & >> right-server-log.log &
2019-12-26 17:35:41 +00:00
right_pid = $!
kill -0 $right_pid
disown $right_pid
set +m
2020-04-17 15:47:01 +00:00
while ! clickhouse-client --port 9001 --query "select 1" ; do kill -0 $left_pid ; echo . ; sleep 1 ; done
2019-12-26 17:35:41 +00:00
echo left ok
2020-04-17 15:47:01 +00:00
while ! clickhouse-client --port 9002 --query "select 1" ; do kill -0 $right_pid ; echo . ; sleep 1 ; done
2019-12-26 17:35:41 +00:00
echo right ok
2019-12-26 21:33:10 +00:00
2020-04-17 15:47:01 +00:00
clickhouse-client --port 9001 --query "select * from system.tables where database != 'system'"
clickhouse-client --port 9001 --query "select * from system.build_options"
clickhouse-client --port 9002 --query "select * from system.tables where database != 'system'"
clickhouse-client --port 9002 --query "select * from system.build_options"
# Check again that both servers we started are running -- this is important
# for running locally, when there might be some other servers started and we
# will connect to them instead.
kill -0 $left_pid
kill -0 $right_pid
2019-12-26 17:35:41 +00:00
}
2019-12-26 19:16:36 +00:00
function run_tests
{
# Just check that the script runs at all
" $script_dir /perf.py " --help > /dev/null
2020-03-12 12:51:09 +00:00
# When testing commits from master, use the older test files. This allows the
# tests to pass even when we add new functions and tests for them, that are
# not supported in the old revision.
# When testing a PR, use the test files from the PR so that we can test their
# changes.
2020-03-12 14:17:08 +00:00
test_prefix = $( [ " $PR_TO_TEST " = = "0" ] && echo left || echo right) /performance
2020-03-12 12:51:09 +00:00
2020-04-22 01:49:59 +00:00
for x in { test-times,skipped-tests,wall-clock-times} .tsv
2020-02-28 20:40:26 +00:00
do
rm -v " $x " || :
touch " $x "
done
2020-02-06 12:46:57 +00:00
2020-02-14 12:55:47 +00:00
2020-03-12 12:51:09 +00:00
# FIXME a quick crutch to bring the run time down for the unstable tests --
2020-02-21 19:58:52 +00:00
# if some performance tests xmls were changed in a PR, run only these ones.
if [ " $PR_TO_TEST " != "0" ]
2020-02-14 12:55:47 +00:00
then
2020-03-12 12:51:09 +00:00
# changed-test.txt prepared in entrypoint.sh from git diffs, because it
# has the cloned repo. Used to use rsync for that but it was really ugly
# and not always correct (e.g. when the reference SHA is really old and
# has some other differences to the tested SHA, besides the one introduced
# by the PR).
2020-04-03 18:23:11 +00:00
test_files_override = $( sed " s/tests\/performance/ ${ test_prefix // \/ / \\ / } / " changed-tests.txt)
2020-02-21 19:58:52 +00:00
if [ " $test_files_override " != "" ]
2020-02-14 12:55:47 +00:00
then
2020-02-14 19:11:46 +00:00
test_files = $test_files_override
2020-02-14 12:55:47 +00:00
fi
fi
# Run only explicitly specified tests, if any
if [ -v CHPC_TEST_GLOB ]
then
2020-02-27 20:02:50 +00:00
# I do want to expand the globs in the variable.
# shellcheck disable=SC2086
2020-03-12 12:51:09 +00:00
test_files = $( ls " $test_prefix " /$CHPC_TEST_GLOB .xml)
2020-02-14 12:55:47 +00:00
fi
2020-04-02 18:44:58 +00:00
if [ " $test_files " = = "" ]
then
# FIXME remove some broken long tests
for test_name in { IPv4,IPv6,modulo,parse_engine_file,number_formatting_formats,select_format,arithmetic,cryptographic_hashes,logical_functions_{ medium,small} }
do
2020-04-17 15:47:01 +00:00
printf "%s\tMarked as broken (see compare.sh)\n" " $test_name " >> skipped-tests.tsv
2020-04-02 18:44:58 +00:00
rm " $test_prefix / $test_name .xml " || :
done
test_files = $( ls " $test_prefix " /*.xml)
fi
2020-02-25 19:51:09 +00:00
# Run the tests.
test_name = "<none>"
2020-02-14 12:55:47 +00:00
for test in $test_files
2019-12-26 19:16:36 +00:00
do
2020-02-25 19:51:09 +00:00
# Check that both servers are alive, to fail faster if they die.
2020-04-17 15:47:01 +00:00
clickhouse-client --port 9001 --query "select 1 format Null" \
2020-02-25 19:51:09 +00:00
|| { echo $test_name >> left-server-died.log ; restart ; continue ; }
2020-04-17 15:47:01 +00:00
clickhouse-client --port 9002 --query "select 1 format Null" \
2020-02-25 19:51:09 +00:00
|| { echo $test_name >> right-server-died.log ; restart ; continue ; }
2020-02-27 20:02:50 +00:00
test_name = $( basename " $test " ".xml" )
echo test " $test_name "
2020-02-14 19:11:46 +00:00
2020-02-06 12:46:57 +00:00
TIMEFORMAT = $( printf " $test_name \t%%3R\t%%3U\t%%3S\n " )
2020-02-11 15:01:16 +00:00
# the grep is to filter out set -x output and keep only time output
2020-04-07 17:55:39 +00:00
{ time " $script_dir /perf.py " --host localhost localhost --port 9001 9002 -- " $test " > " $test_name -raw.tsv " 2> " $test_name -err.log " ; } 2>& 1 >/dev/null | grep -v ^+ >> "wall-clock-times.tsv" || continue
2020-02-14 19:11:46 +00:00
2020-03-02 17:05:53 +00:00
# The test completed with zero status, so we treat stderr as warnings
mv " $test_name -err.log " " $test_name -warn.log "
2020-01-16 19:39:07 +00:00
grep ^query " $test_name -raw.tsv " | cut -f2- > " $test_name -queries.tsv "
grep ^client-time " $test_name -raw.tsv " | cut -f2- > " $test_name -client-time.tsv "
2020-02-28 16:22:07 +00:00
skipped = $( grep ^skipped " $test_name -raw.tsv " | cut -f2-)
if [ " $skipped " != "" ]
then
2020-04-17 15:47:01 +00:00
printf "%s\t%s\n" " $test_name " " $skipped " >> skipped-tests.tsv
2020-02-28 16:22:07 +00:00
fi
2019-12-26 19:16:36 +00:00
done
2020-02-14 12:55:47 +00:00
2020-02-14 19:11:46 +00:00
unset TIMEFORMAT
2020-02-14 12:55:47 +00:00
wait
2020-02-14 19:11:46 +00:00
}
2020-02-14 12:55:47 +00:00
2020-04-21 21:53:13 +00:00
function get_profiles_watchdog
{
sleep 3000
echo "The trace collection did not finish in time." >> report-errors.rep
for pid in $( pgrep -f clickhouse)
do
gdb -p $pid --batch --ex "info proc all" --ex "thread apply all bt" --ex quit & > " $pid .gdb.log " &
done
wait
for i in { 1..10}
do
if ! pkill -f clickhouse
then
break
fi
sleep 1
done
}
2020-02-14 19:11:46 +00:00
function get_profiles
{
2020-02-14 12:55:47 +00:00
# Collect the profiles
2020-04-17 15:47:01 +00:00
clickhouse-client --port 9001 --query "set query_profiler_cpu_time_period_ns = 0"
clickhouse-client --port 9001 --query "set query_profiler_real_time_period_ns = 0"
clickhouse-client --port 9001 --query "set query_profiler_cpu_time_period_ns = 0"
clickhouse-client --port 9001 --query "set query_profiler_real_time_period_ns = 0"
clickhouse-client --port 9001 --query "system flush logs"
clickhouse-client --port 9002 --query "system flush logs"
clickhouse-client --port 9001 --query "select * from system.query_log where type = 2 format TSVWithNamesAndTypes" > left-query-log.tsv || : &
clickhouse-client --port 9001 --query "select * from system.query_thread_log format TSVWithNamesAndTypes" > left-query-thread-log.tsv || : &
clickhouse-client --port 9001 --query "select * from system.trace_log format TSVWithNamesAndTypes" > left-trace-log.tsv || : &
clickhouse-client --port 9001 --query "select arrayJoin(trace) addr, concat(splitByChar('/', addressToLine(addr))[-1], '#', demangle(addressToSymbol(addr)) ) name from system.trace_log group by addr format TSVWithNamesAndTypes" > left-addresses.tsv || : &
clickhouse-client --port 9001 --query "select * from system.metric_log format TSVWithNamesAndTypes" > left-metric-log.tsv || : &
clickhouse-client --port 9002 --query "select * from system.query_log where type = 2 format TSVWithNamesAndTypes" > right-query-log.tsv || : &
clickhouse-client --port 9002 --query "select * from system.query_thread_log format TSVWithNamesAndTypes" > right-query-thread-log.tsv || : &
clickhouse-client --port 9002 --query "select * from system.trace_log format TSVWithNamesAndTypes" > right-trace-log.tsv || : &
clickhouse-client --port 9002 --query "select arrayJoin(trace) addr, concat(splitByChar('/', addressToLine(addr))[-1], '#', demangle(addressToSymbol(addr)) ) name from system.trace_log group by addr format TSVWithNamesAndTypes" > right-addresses.tsv || : &
clickhouse-client --port 9002 --query "select * from system.metric_log format TSVWithNamesAndTypes" > right-metric-log.tsv || : &
2020-02-14 12:55:47 +00:00
wait
2019-12-26 19:16:36 +00:00
}
2019-12-26 17:35:41 +00:00
2020-03-02 18:47:37 +00:00
# Build and analyze randomization distribution for all queries.
function analyze_queries
{
2020-04-17 15:47:01 +00:00
find . -maxdepth 1 -name "*-queries.tsv" -print0 | \
xargs -0 -n1 -I% basename % -queries.tsv | \
parallel --verbose clickhouse-local --file "{}-queries.tsv" \
2020-03-02 18:47:37 +00:00
--structure "\"query text, run int, version UInt32, time float\"" \
--query " \" $( cat " $script_dir /eqmed.sql " ) \" " \
">" { } -report.tsv
}
2019-12-26 19:16:36 +00:00
# Analyze results
2020-02-07 18:34:24 +00:00
function report
{
2020-02-17 19:32:40 +00:00
2020-03-17 16:37:09 +00:00
for x in { right,left} -{ addresses,{ query,query-thread,trace,metric} -log} .tsv
2020-02-17 19:32:40 +00:00
do
# FIXME This loop builds column definitons from TSVWithNamesAndTypes in an
# absolutely atrocious way. This should be done by the file() function itself.
paste -d' ' \
2020-02-20 16:28:21 +00:00
<( sed -n '1{s/\t/\n/g;p;q}' " $x " | sed 's/\(^.*$\)/"\1"/' ) \
<( sed -n '2{s/\t/\n/g;p;q}' " $x " ) \
2020-02-17 19:32:40 +00:00
| tr '\n' ', ' | sed 's/,$//' > " $x .columns "
done
2020-02-27 20:02:50 +00:00
rm ./*.{ rep,svg} test-times.tsv test-dump.tsv unstable.tsv unstable-query-ids.tsv unstable-query-metrics.tsv changed-perf.tsv unstable-tests.tsv unstable-queries.tsv bad-tests.tsv slow-on-client.tsv all-queries.tsv || :
2020-02-17 19:32:40 +00:00
2020-04-17 15:47:01 +00:00
clickhouse-local --query "
2020-03-24 17:33:18 +00:00
create table queries engine File( TSVWithNamesAndTypes, 'queries.rep' )
2020-03-23 09:39:12 +00:00
as select
2020-02-11 20:00:53 +00:00
-- FIXME Comparison mode doesn' t make sense for queries that complete
-- immediately, so for now we pretend they don't exist. We don' t want to
-- remove them altogether because we want to be able to detect regressions,
-- but the right way to do this is not yet clear.
2020-04-21 18:46:45 +00:00
( left + right) / 2 < 0.02 as short,
2020-02-28 19:59:59 +00:00
2020-04-21 18:46:45 +00:00
-- Difference > 5% and > rd( 99%) -- changed. We can' t filter out flaky
2020-04-17 13:32:59 +00:00
-- queries by rd( 5%) , because it can be zero when the difference is smaller
-- than a typical distribution width. The difference is still real though.
2020-04-21 18:46:45 +00:00
not short and abs( diff) > 0.05 and abs( diff) > rd[ 4] as changed,
2020-04-17 13:32:59 +00:00
2020-04-21 18:46:45 +00:00
-- Not changed but rd( 99%) > 5% -- unstable.
not short and not changed and rd[ 4] > 0.05 as unstable,
2020-04-17 13:32:59 +00:00
2020-03-24 17:33:18 +00:00
left, right, diff, rd,
replaceAll( _file, '-report.tsv' , '' ) test,
2020-04-21 18:46:45 +00:00
-- Truncate long queries.
if ( length( query) < 300, query, substr( query, 1, 298) || '...' ) query
2020-02-11 20:00:53 +00:00
from file( '*-report.tsv' , TSV, 'left float, right float, diff float, rd Array(float), query text' ) ;
2020-02-07 18:34:24 +00:00
2020-02-10 16:34:07 +00:00
create table changed_perf_tsv engine File( TSV, 'changed-perf.tsv' ) as
select left, right, diff, rd, test, query from queries where changed
2020-04-21 18:46:45 +00:00
order by abs( diff) desc;
2020-02-11 20:00:53 +00:00
2020-02-10 16:34:07 +00:00
create table unstable_queries_tsv engine File( TSV, 'unstable-queries.tsv' ) as
2020-03-02 15:55:07 +00:00
select left, right, diff, rd, test, query from queries where unstable
2020-04-21 18:46:45 +00:00
order by rd[ 4] desc;
2020-02-11 20:00:53 +00:00
2020-02-10 16:34:07 +00:00
create table unstable_tests_tsv engine File( TSV, 'bad-tests.tsv' ) as
select test, sum( unstable) u, sum( changed) c, u + c s from queries
2020-02-07 18:34:24 +00:00
group by test having s > 0 order by s desc;
2020-02-10 16:34:07 +00:00
create table query_time engine Memory as select *, replaceAll( _file, '-client-time.tsv' , '' ) test
2020-02-07 18:34:24 +00:00
from file( '*-client-time.tsv' , TSV, 'query text, client float, server float' ) ;
2020-02-10 16:34:07 +00:00
create table wall_clock engine Memory as select *
from file( 'wall-clock-times.tsv' , TSV, 'test text, real float, user float, system float' ) ;
2020-02-07 18:34:24 +00:00
create table slow_on_client_tsv engine File( TSV, 'slow-on-client.tsv' ) as
2020-02-10 16:34:07 +00:00
select client, server, floor( client/server, 3) p, query
from query_time where p > 1.02 order by p desc;
create table test_time engine Memory as
2020-02-11 15:01:16 +00:00
select test, sum( client) total_client_time,
2020-02-11 20:00:53 +00:00
maxIf( client, not short) query_max,
minIf( client, not short) query_min,
count( *) queries,
sum( short) short_queries
from query_time, queries
where query_time.query = queries.query
2020-02-11 15:01:16 +00:00
group by test;
2020-02-07 18:34:24 +00:00
create table test_times_tsv engine File( TSV, 'test-times.tsv' ) as
2020-02-11 15:01:16 +00:00
select wall_clock.test, real,
floor( total_client_time, 3) ,
queries,
2020-02-11 20:00:53 +00:00
short_queries,
2020-02-11 15:01:16 +00:00
floor( query_max, 3) ,
floor( real / queries, 3) avg_real_per_query,
floor( query_min, 3)
2020-02-11 20:00:53 +00:00
from test_time join wall_clock using test
2020-02-14 12:55:47 +00:00
order by avg_real_per_query desc;
2020-02-10 16:34:07 +00:00
2020-04-02 18:44:58 +00:00
create table all_tests_tsv engine File( TSV, 'all-queries.tsv' ) as
select left, right, diff,
floor( left > right ? left / right : right / left, 3) ,
rd, test, query
from queries order by test, query;
2020-03-24 17:33:18 +00:00
" 2> >(head -2 >> report-errors.rep) ||:
for version in { right,left}
do
2020-04-17 15:47:01 +00:00
clickhouse-local --query "
2020-03-24 17:33:18 +00:00
create view queries as
select * from file( 'queries.rep' , TSVWithNamesAndTypes,
2020-04-22 13:11:46 +00:00
' short int, changed int, unstable int, left float, right float,
2020-03-24 17:33:18 +00:00
diff float, rd Array( float) , test text, query text' ) ;
2020-02-17 19:32:40 +00:00
2020-03-24 17:33:18 +00:00
create view query_log as select *
from file( '$version-query-log.tsv' , TSVWithNamesAndTypes,
'$(cat "$version-query-log.tsv.columns")' ) ;
2020-02-17 19:32:40 +00:00
2020-03-24 17:33:18 +00:00
create view trace_log as select *
from file( '$version-trace-log.tsv' , TSVWithNamesAndTypes,
'$(cat "$version-trace-log.tsv.columns")' ) ;
2020-02-17 19:32:40 +00:00
2020-03-24 17:33:18 +00:00
create view addresses_src as select *
from file( '$version-addresses.tsv' , TSVWithNamesAndTypes,
'$(cat "$version-addresses.tsv.columns")' ) ;
2020-02-17 19:32:40 +00:00
2020-03-24 17:33:18 +00:00
create table addresses_join engine Join( any, left, address) as
select addr address, name from addresses_src;
2020-02-20 16:28:21 +00:00
2020-03-24 17:33:18 +00:00
create table unstable_query_runs engine File( TSVWithNamesAndTypes,
'unstable-query-runs.$version.rep' ) as
select query_id, query from query_log
2020-03-02 15:55:07 +00:00
join queries using query
where query_id not like 'prewarm %' and ( unstable or changed)
2020-02-17 19:32:40 +00:00
;
2020-03-24 17:33:18 +00:00
create table unstable_query_log engine File( Vertical,
'unstable-query-log.$version.rep' ) as
select * from query_log
2020-02-20 16:28:21 +00:00
where query_id in ( select query_id from unstable_query_runs) ;
2020-03-24 17:33:18 +00:00
create table unstable_run_metrics engine File( TSVWithNamesAndTypes,
'unstable-run-metrics.$version.rep' ) as
2020-02-17 19:32:40 +00:00
select ProfileEvents.Values value, ProfileEvents.Names metric, query_id, query
2020-03-24 17:33:18 +00:00
from query_log array join ProfileEvents
2020-02-20 16:28:21 +00:00
where query_id in ( select query_id from unstable_query_runs)
2020-02-17 19:32:40 +00:00
;
2020-03-24 17:33:18 +00:00
create table unstable_run_metrics_2 engine File( TSVWithNamesAndTypes,
'unstable-run-metrics-2.$version.rep' ) as
2020-02-20 16:28:21 +00:00
select v, n, query_id, query
from
( select
2020-03-17 02:41:47 +00:00
[ 'memory_usage' , 'read_bytes' , 'written_bytes' , 'query_duration_ms' ] n,
[ memory_usage, read_bytes, written_bytes, query_duration_ms] v,
2020-02-20 16:28:21 +00:00
query,
query_id
2020-03-24 17:33:18 +00:00
from query_log
2020-02-20 16:28:21 +00:00
where query_id in ( select query_id from unstable_query_runs) )
array join n, v;
2020-03-24 17:33:18 +00:00
create table unstable_run_traces engine File( TSVWithNamesAndTypes,
'unstable-run-traces.$version.rep' ) as
select
count( ) value,
joinGet( addresses_join, 'name' , arrayJoin( trace) ) metric,
unstable_query_runs.query_id,
any( unstable_query_runs.query) query
2020-02-20 16:28:21 +00:00
from unstable_query_runs
2020-03-24 17:33:18 +00:00
join trace_log on trace_log.query_id = unstable_query_runs.query_id
2020-02-20 16:28:21 +00:00
group by unstable_query_runs.query_id, metric
2020-02-17 19:32:40 +00:00
order by count( ) desc
;
2020-03-24 17:33:18 +00:00
create table metric_devation engine File( TSVWithNamesAndTypes,
'metric-deviation.$version.rep' ) as
2020-04-21 18:46:45 +00:00
select query, floor( ( q[ 3] - q[ 1] ) /q[ 2] , 3) d,
quantilesExact( 0, 0.5, 1) ( value) q, metric
2020-02-20 16:28:21 +00:00
from ( select * from unstable_run_metrics
union all select * from unstable_run_traces
2020-02-27 17:57:08 +00:00
union all select * from unstable_run_metrics_2) mm
2020-02-17 19:32:40 +00:00
join queries using query
group by query, metric
having d > 0.5
2020-03-18 01:28:57 +00:00
order by any( rd[ 3] ) desc, query desc, d desc
2020-02-17 19:32:40 +00:00
;
2020-02-20 16:28:21 +00:00
2020-03-24 17:33:18 +00:00
create table stacks engine File( TSV, 'stacks.$version.rep' ) as
2020-02-20 16:28:21 +00:00
select
query,
arrayStringConcat(
2020-03-24 17:33:18 +00:00
arrayMap( x -> joinGet( addresses_join, 'name' , x) ,
2020-02-20 16:28:21 +00:00
arrayReverse( trace)
) ,
';'
) readable_trace,
count( )
2020-03-24 17:33:18 +00:00
from trace_log
2020-02-20 16:28:21 +00:00
join unstable_query_runs using query_id
group by query, trace
;
2020-03-24 17:33:18 +00:00
" 2> >(head -2 >> report-errors.rep) ||: # do not run in parallel because they use the same data dir for StorageJoins which leads to weird errors.
done
wait
2020-02-11 15:01:16 +00:00
2020-02-20 16:28:21 +00:00
IFS = $'\n'
2020-03-24 17:33:18 +00:00
for version in { right,left}
2020-02-20 16:28:21 +00:00
do
2020-03-24 17:33:18 +00:00
for query in $( cut -d' ' -f1 " stacks. $version .rep " | sort | uniq)
do
query_file = $( echo " $query " | cut -c-120 | sed 's/[/]/_/g' )
2020-04-21 18:46:45 +00:00
# Build separate .svg flamegraph for each query.
2020-03-24 17:33:18 +00:00
grep -F " $query " " stacks. $version .rep " \
| cut -d' ' -f 2- \
| sed 's/\t/ /g' \
| tee " $query_file .stacks. $version .rep " \
| ~/fg/flamegraph.pl > " $query_file . $version .svg " &
2020-04-21 18:46:45 +00:00
# Copy metric stats into separate files as well.
grep -F " $query " " metric-deviation. $version .rep " \
| cut -f2- > " $query_file . $version .metrics.rep " &
2020-03-24 17:33:18 +00:00
done
2020-02-20 16:28:21 +00:00
done
wait
unset IFS
2020-02-11 15:01:16 +00:00
# Remember that grep sets error code when nothing is found, hence the bayan
2020-03-02 18:47:37 +00:00
# operator.
2020-04-03 18:23:11 +00:00
grep -H -m2 -i '\(Exception\|Error\):[^:]' ./*-err.log | sed 's/:/\t/' > run-errors.tsv || :
2020-02-07 18:34:24 +00:00
}
2020-02-10 18:37:46 +00:00
2020-04-17 15:47:01 +00:00
# Check that local and client are in PATH
clickhouse-local --version > /dev/null
clickhouse-client --version > /dev/null
2020-02-10 18:37:46 +00:00
case " $stage " in
"" )
; &
2020-02-14 19:11:46 +00:00
"configure" )
time configure
; &
"restart" )
time restart
; &
"run_tests" )
2020-03-17 16:37:09 +00:00
# Ignore the errors to collect the log and build at least some report, anyway
2020-02-25 19:51:09 +00:00
time run_tests || :
2020-02-14 19:11:46 +00:00
; &
"get_profiles" )
2020-04-21 21:53:13 +00:00
# Getting profiles inexplicably hangs sometimes, so try to save some logs if
# this happens again. Give the servers 5 minutes to collect all info, then
# trace and kill. Start in a subshell, so that both function don't interfere
# with each other's jobs through `wait`. Also make the subshell have its own
# process group, so that we can then kill it with all its child processes.
# Somehow it doesn't kill the children by itself when dying.
set -m
( get_profiles_watchdog ) &
watchdog_pid = $!
set +m
# Check that the watchdog started OK.
kill -0 $watchdog_pid
2020-02-28 16:22:07 +00:00
# If the tests fail with OOM or something, still try to restart the servers
# to collect the logs. Prefer not to restart, because addresses might change
2020-04-21 21:53:13 +00:00
# and we won't be able to process trace_log data. Start in a subshell, so that
# it doesn't interfere with the watchdog through `wait`.
( time get_profiles || restart || get_profiles || : )
# Kill the whole process group, because somehow when the subshell is killed,
# the sleep inside remains alive and orphaned.
while env kill -- -$watchdog_pid ; do sleep 1; done
2020-03-03 10:47:32 +00:00
# Stop the servers to free memory for the subsequent query analysis.
while killall clickhouse; do echo . ; sleep 1 ; done
echo Servers stopped.
2020-02-10 18:37:46 +00:00
; &
2020-02-27 19:43:43 +00:00
"analyze_queries" )
2020-03-17 16:37:09 +00:00
time analyze_queries || :
2020-02-27 19:43:43 +00:00
; &
2020-02-10 18:37:46 +00:00
"report" )
2020-03-17 16:37:09 +00:00
time report || :
2020-04-02 18:44:58 +00:00
time " $script_dir /report.py " --report= all-queries > all-queries.html 2> >( head -2 >> report-errors.rep) || :
2020-03-17 16:37:09 +00:00
time " $script_dir /report.py " > report.html
2020-02-10 18:37:46 +00:00
; &
esac
2020-04-21 21:53:13 +00:00
# Print some final debug info to help debug Weirdness, of which there is plenty.
jobs
pstree -apgT